JUCE: OpenGLRenderer Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
OpenGLRenderer Class Referenceabstract
juce_opengl » opengl

A base class that should be implemented by classes which want to render openGL on a background thread. More...

`#include <juce_OpenGLRenderer.h>`

Inheritance diagram for OpenGLRenderer:

## Public Member Functions
| OpenGLRenderer ()=default
virtual | ~OpenGLRenderer ()=default
virtual void | newOpenGLContextCreated ()=0
| Called when a new GL context has been created.
virtual void | renderOpenGL ()=0
| Called when you should render the next openGL frame.
virtual void | openGLContextClosing ()=0
| Called when the current openGL context is about to close.

## Detailed Description

A base class that should be implemented by classes which want to render openGL on a background thread.

See also
  OpenGLContext

## Constructor & Destructor Documentation

## ◆ OpenGLRenderer()

OpenGLRenderer::OpenGLRenderer | ( |  | ) |
| default

## ◆ ~OpenGLRenderer()

virtual OpenGLRenderer::~OpenGLRenderer | ( |  | ) |
| virtualdefault

## Member Function Documentation

## ◆ newOpenGLContextCreated()

virtual void OpenGLRenderer::newOpenGLContextCreated | ( |  | ) |
| pure virtual

Called when a new GL context has been created.

You can use this as an opportunity to create your textures, shaders, etc. When the method is invoked, the new GL context will be active. Note that this callback will be made on a background thread, so make sure that your implementation is thread-safe.

## ◆ renderOpenGL()

virtual void OpenGLRenderer::renderOpenGL | ( |  | ) |
| pure virtual

Called when you should render the next openGL frame.

Note that this callback will be made on a background thread.

If the context is attached to a component in order to do component rendering, then the MessageManager will be locked when this callback is made.

If no component rendering is being done, then the MessageManager will not be locked, and you'll need to make sure your code is thread-safe in any interactions it has with your GUI classes.

For information about how to trigger a render callback, see OpenGLContext::triggerRepaint() and OpenGLContext::setContinuousRepainting().

IMPORTANT: Never take a MessageManagerLock inside this function! On macOS, the OpenGL context will be locked for the duration of this call. The main thread may also attempt to interact with the OpenGL context at any time, which will also require locking the OpenGL context. As a result, taking a MessageManagerLock inside renderOpenGL() may cause a hierarchical deadlock.

## ◆ openGLContextClosing()

virtual void OpenGLRenderer::openGLContextClosing | ( |  | ) |
| pure virtual

Called when the current openGL context is about to close.

You can use this opportunity to release any GL resources that you may have created.

Note that this callback will be made on a background thread, so make sure that your implementation is thread-safe.

(Also note that on Android, this callback won't happen, because there's currently no way to implement it..)

The documentation for this class was generated from the following file:

- juce_OpenGLRenderer.h